package client

const (
	ServiceSpecType                          = "serviceSpec"
	ServiceSpecFieldClusterIp                = "clusterIp"
	ServiceSpecFieldExternalIPs              = "externalIPs"
	ServiceSpecFieldExternalTrafficPolicy    = "externalTrafficPolicy"
	ServiceSpecFieldHealthCheckNodePort      = "healthCheckNodePort"
	ServiceSpecFieldHostname                 = "hostname"
	ServiceSpecFieldLoadBalancerIP           = "loadBalancerIP"
	ServiceSpecFieldLoadBalancerSourceRanges = "loadBalancerSourceRanges"
	ServiceSpecFieldPorts                    = "ports"
	ServiceSpecFieldPublishNotReadyAddresses = "publishNotReadyAddresses"
	ServiceSpecFieldSelector                 = "selector"
	ServiceSpecFieldServiceKind              = "serviceKind"
	ServiceSpecFieldSessionAffinity          = "sessionAffinity"
	ServiceSpecFieldSessionAffinityConfig    = "sessionAffinityConfig"
)

type ServiceSpec struct {
	ClusterIp                string                 `json:"clusterIp,omitempty" yaml:"clusterIp,omitempty"`
	ExternalIPs              []string               `json:"externalIPs,omitempty" yaml:"externalIPs,omitempty"`
	ExternalTrafficPolicy    string                 `json:"externalTrafficPolicy,omitempty" yaml:"externalTrafficPolicy,omitempty"`
	HealthCheckNodePort      int64                  `json:"healthCheckNodePort,omitempty" yaml:"healthCheckNodePort,omitempty"`
	Hostname                 string                 `json:"hostname,omitempty" yaml:"hostname,omitempty"`
	LoadBalancerIP           string                 `json:"loadBalancerIP,omitempty" yaml:"loadBalancerIP,omitempty"`
	LoadBalancerSourceRanges []string               `json:"loadBalancerSourceRanges,omitempty" yaml:"loadBalancerSourceRanges,omitempty"`
	Ports                    []ServicePort          `json:"ports,omitempty" yaml:"ports,omitempty"`
	PublishNotReadyAddresses bool                   `json:"publishNotReadyAddresses,omitempty" yaml:"publishNotReadyAddresses,omitempty"`
	Selector                 map[string]string      `json:"selector,omitempty" yaml:"selector,omitempty"`
	ServiceKind              string                 `json:"serviceKind,omitempty" yaml:"serviceKind,omitempty"`
	SessionAffinity          string                 `json:"sessionAffinity,omitempty" yaml:"sessionAffinity,omitempty"`
	SessionAffinityConfig    *SessionAffinityConfig `json:"sessionAffinityConfig,omitempty" yaml:"sessionAffinityConfig,omitempty"`
}
